#include <iocontrol.h>
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <WiFiUDP.h>
#include "WakeOnLan.h"




const char* ssid      = "";
const char* password  = "atim";
boolean wifiConnected = false;

WiFiUDP UDP;
IPAddress computer_ip(255,255,255,255); 
byte mac[] = { 0x18, 0x03, 0x73, 0x22, 0x1c, 0x23 };

const char* key = "";


boolean connectWifi();
void sendWOL();
void WritePanel();

// Название панели на сайте iocontrol.ru
const char* myPanelName = "";
int status;

// Название переменных как на сайте iocontrol.ru
const char* VarName_wol = "wol";

// Отпечаток сертификат SSL сайта iocontrol.ru, так же его можно получить из браузера,
// нажав на пиктограмму замка рядом с полем ввода адреса
const char fingerprint[] PROGMEM = "04 3f 32 b1 f5 33 20 cf 28 75 e0 f6 96 28 e6 ba 37 3a 9c 5e";

// Создаём объект клиента
WiFiClientSecure client;

// Создаём объект iocontrol, передавая в конструктор название панели и клиента
iocontrol mypanel(myPanelName, key, client);


void setup()
{
    Serial.begin(115200);
    WiFi.begin(ssid, password);
    pinMode(LED_BUILTIN, OUTPUT);
    
    // Ждём подключения
    while (WiFi.status() != WL_CONNECTED) {
        Serial.print(".");
        delay(500);
    }

    // Устанавливаем отпечаток SSL/TLS сертификата
    client.setFingerprint(fingerprint);
    
    /* Функция setHttps() переключает порт с 80 на 443
       и меняет процесс формирование строки запроса */

    // Переключаем режим работы объекта библиотеки
    mypanel.setHttps();
   
    // Вызываем функцию первого запроса к сервису
    mypanel.begin();

   UDP.begin(9); 

}

void WritePanel() {
    mypanel.write(VarName_wol, 0);
    status = mypanel.writeUpdate();

    if (status == OK) {
        // Выводим текст в последовательный порт
        Serial.println("------- Write OK -------");
    }
  
  }

void loop()
{
    // Чтение значений переменных из сервиса
    status = mypanel.readUpdate();

    // Если статус равен константе OK...
    if (status == OK) {
        int io_wol = mypanel.readInt(VarName_wol);   
        if (io_wol == 1) {
                for (int i = 0; i < 4; i++) {
                      digitalWrite(LED_BUILTIN, LOW); 
                      WakeOnLan::sendWOL(computer_ip, UDP, mac, sizeof mac);
                      delay(2000); 
                      digitalWrite(LED_BUILTIN, HIGH);
                      delay(2000);
                  }   
     WritePanel();
       }
  } 

delay(5000);

}
